#include <mega32.h>
#include <alcd.h>
#include <stdio.h>
#include <delay.h>
//PINB.7 MENUE    PINB.6 START      PINB.5    ESCAPE 
 unsigned char input[2][2];
 unsigned char inputf[2][2];
volatile unsigned char x; 
int DEL =100;    //the debounce delay for the keys 
volatile unsigned  char finalr,finalg,finalb;
eeprom float rg,gg,bg;  //scalings for the input red , green and blue ferquencys
float rg1,gg1,bg1;     //Tempararry saveing for rg gg , bg 
volatile char burest=0;
void color_select(char color)
{
DDRB.1=1;
DDRB.0=1;
 switch (color)
 { 
 case 1:
 PORTB.0=0;
 PORTB.1=0;
 break;
 case 4:
 PORTB.0=1;
 PORTB.1=0;
 break; 
 case 3:
 PORTB.0=0;
 PORTB.1=1;
 break;
 case 2:
 PORTB.0=1;
 PORTB.1=1;
 break;
 }



}
interrupt [TIM1_CAPT] void timer1_cap(void)
{
  input[x][0]=ICR1L;
  input[x][1]=ICR1H;
  if (x==1)
  {
   inputf[0][0]=input[0][0];
   inputf[0][1]=input[0][1];
   inputf[1][0]=input[1][0];
   inputf[1][1]=input[1][1];
   x=0;
   TCNT1H=0;
   TCNT1L=0;
  }
   else  x+=1;
}
float getferq(void)
{
   int h1,h2;
   unsigned char l1,l2;
   float temp;
   x=0;
   TCNT1H=0;
   TCNT1L=0; 
   #asm("sei");
   delay_ms(20);
   #asm("cli");
   l1=inputf[0][0];
   h1=inputf[0][1];
   l2=inputf[1][0];
   h2=inputf[1][1];
   h1=(h1<<8)|l1; 
   h2=((h2<<8)|l2); 
   temp=h2-h1;
   temp=((1/(temp))*8000000);
   return temp;
} 
void start(void)
{ 
 int red1,green1,blue1;
float red,green,blue;  
 
 lcd_clear();
 lcd_gotoxy(0,0);
 lcd_putsf("Ready for scan?");
 lcd_gotoxy(0,1);
 lcd_putsf("Yes           No");
  while(1)
 {
   if (PINB.7==1){
   delay_ms(DEL);
   if (PINB.7==1){
   break;
   }
  }
  
    if (PINB.6==1){
   delay_ms(DEL);
   if (PINB.6==1){
   return;
   }
  } 
 color_select(1);
 red=getferq();
 color_select(2);
 green=getferq();
 color_select(3);
 blue=getferq();
 red1=red*rg;
 green1=green*gg;
 blue1=blue*bg;
 red1&=0xFF;
 green1&=0xFF;
 blue1&=0xFF;
 finalr=red1;
 finalg=green1;
 finalb=blue1;
 }
}
void wb(void){
  float red,green,blue;
 lcd_clear();
 lcd_gotoxy(0,0);
 lcd_putsf("Ready for wb?");
 lcd_gotoxy(0,1);
 lcd_putsf("Yes           No");
  while(1)
 {
   if (PINB.7==1){
   delay_ms(DEL);
   if (PINB.7==1){
   break;
   }
  }
  
    if (PINB.6==1){
   delay_ms(DEL);
   if (PINB.6==1){
   return;
   }
  } 
 color_select(1);
 red=getferq();
 color_select(2);
 green=getferq();
 color_select(3);
 blue=getferq();
 rg=(255/red);
 gg=(255/green);
 bg=(255/blue);
 }
}
char main_screen(void){
char lcd_out[];
lcd_clear();
lcd_gotoxy(0,0);
sprintf(lcd_out,"R:%3dG:%3dB:%3d",finalr,finalg,finalb);
lcd_puts(lcd_out);
lcd_gotoxy(0,1);
lcd_putsf("start      menue");
 if (burest){
 return 's';
 }
  while(1)
 {
   if (PINB.7==1){
   delay_ms(DEL);
   if (PINB.7==1){
   return 's';
   }
  }
  if (PINB.6==1){
   delay_ms(DEL);
   if (PINB.6==1){
   return 'm';
   }
  }
 }

}
char menue(void){
lcd_clear();
lcd_gotoxy(0,1);
lcd_putsf("WB        Escape");
 while(1){
  if (PINB.7==1){
   delay_ms(DEL);
   if (PINB.7==1){
   return 'w';
   }
  }
   
   if (PINB.6==1){
   delay_ms(DEL);
   if (PINB.6==1){
   return 'b';
   } 
  }
  
   if (PINB.5==1){
  delay_ms(DEL);
   if (PINB.5==1){
    return 's';
   }
  }
 } 
}
void main (void)
{
char sit;
rg1=rg;
gg1=gg;
bg1=bg;
TCCR1B|=(1<<CS10)|(1<<ICES1);
TIMSK|=(1<<TICIE1);
DDRB|=(1<<DDB7)|(1<<DDB6)|(1<<DDB5);
lcd_init(16);
lcd_putsf("     Hello!     " );
delay_ms(500);
   while(1)
  {
    sit=main_screen();
     if (sit=='m'){
      sit=menue();
       if (sit=='w'){
       wb();
      }
      else if(sit=='b')
      {
     //set burest if you want this option
      }
     }
    else if(sit=='s'){
      start();
    } 
  } 

}